#####################################################################################
#
#   dicing.tcl
#        IRC.
#          ,
#      .
#         MySQL   mysqltcl3.05.
#
#     :
#    !/!start -  
#    !/!stop -  
#    !/!top -   
#    !/!rate <> -  
#    !/!score -   
#    !/!transfer <> <> -     
#
#     :
#    !/!reg <> <> -   
#    !/!ident <> <> -   
#    !/!leave -   
#    !/!score -   
#    !/!transfer <> <> -     
#
#      DCC:
#    .help dicing -      
#    .dicing give <> <> -    
#    .dicing take <> <> -     .
#    .dicing pass <> <> -   
#    .dicing score <> [] -    (   -    )
#    .dicing number [] - /    
#
#	: freaky @ YakNet 
#	 : http://www.anarxist.net
#	    casino.tcl  : Deniska @ RusNet 
#	 : http://eggdrop.org.ru
#
#####################################################################################
#
#    - ,     TCL.
#       dicing.cfg.tcl
#

if { [lsearch [info loaded] "*libmysqltcl[info sharedlibextension] Mysqltcl"] == -1 } {
	putlog "  MySQLTCL.."
	switch $tcl_platform(platform) {
		windows { cd modules;load libmysqltcl.dll;cd ..	}
		unix { load [file join [pwd] modules/libmysqltcl3.05[info sharedlibextension]] }
	}
}

if { ![info exists ::sp_version] } {
	putlog ": Suzi Patch  .     SP."
}

# 
if {[info exists ::dicing::utimer]} { if { $::dicing::utimer ne "" } { catch {killutimer $::dicing::utimer}; set ::dicing::utimer "" }}
if {[info exists ::dicing::utimer2]} { if { $::dicing::utimer2 ne "" } { catch {killutimer $::dicing::utimer2};set ::dicing::utimer2 "" }}
foreach b [binds ::dicing::*] { unbind [lindex $b 0] [lindex $b 1] [lindex $b 2] [lindex $b 4] }
if { [info exists dbcon] } {
	if { $dbcon ne "" } { ::mysql::close $dbcon }
}

namespace eval dicing {
set loadstart [clock clicks]

#  
variable version 1.5.1b

# 
variable author "freaky @ YakNet"

#   
source scripts/dicing.cfg.tcl

#    
source scripts/dicing.adm.tcl

#    .
source scripts/dicing.msg.tcl

#    
bind pub mn "${pref}" ::dicing::start
bind pub mn "${pref}start" ::dicing::start
bind pub mn "${pref}stop" ::dicing::stop
bind pub mn "${pref}" ::dicing::stop
bind msg - "${pref}reg" ::dicing::reg
bind msg - "${pref}" ::dicing::reg
bind msg - "${pref}ident" ::dicing::ident
bind msg - "${pref}" ::dicing::ident
bind msg - "${pref}" ::dicing::leave
bind msg - "${pref}leave" ::dicing::leave
bind msg - "${pref}score" ::dicing::score
bind msg - "${pref}" ::dicing::score
bind pub - "${pref}top" ::dicing::top
bind pub - "${pref}" ::dicing::top
bind pub - "${pref}score" ::dicing::score
bind pub - "${pref}" ::dicing::score
bind msg - "${pref}transfer" ::dicing::transfer
bind msg - "${pref}" ::dicing::transfer
bind pub - "${pref}transfer" ::dicing::transfer
bind pub - "${pref}" ::dicing::transfer

#    
bind pub - "${pref}" ::dicing::rate
bind pub - "${pref}rate" ::dicing::rate

################################################################################
#
#     , ,  .
#
#      ,       TCL.
#
################################################################################

setudef flag $flag

variable started 0;variable utimer2 "";variable roundstarted 0
variable rate "";variable players "";variable number "";variable utimer "";variable dbcon ""
if { [array exists pls] } { array unset pls }
array set pls {}

################################################################################
#
# MySQL
#	 ,      .
#


#        
proc checkdbsettings { {targ ""} } {
	variable host;variable user;variable pass;variable name;variable port
	if { $host eq "" || $user eq "" || $pass eq ""	|| $name eq "" || $port eq "" } {
		if { $targ ne "" } { putquick "privmsg $targ :[msg 1]" } else {	putlog [msg 1] }
    return 0
	}

	if { [string tolower $host] eq "localhost" && [string index $port 0] ne "/" && [info sharedlibextension] ne ".dll" } {
		if { $targ ne "" } { putquick "privmsg $targ :[msg 2]" } else {	putlog [msg 2] }
    return 0
	}
	return 1
}

#    MySQL
proc initconnect { {targ ""} } {
	variable host;variable user;variable name;variable pass;variable port;variable dbcon
	if { [checkdbsettings $targ] } {
		if { [string index $port 0] eq "/" } { 
			set dbcon [::mysql::connect -host $host -user $user -password $pass -db $name -socket $port -encoding cp1251]
		} else { 
			set dbcon [::mysql::connect -host $host -user $user -password $pass -db $name -port $port -encoding cp1251]
		}
		set err [::mysql::info $dbcon sqlstate]
		if { $err ne "00000" } {
			if { $targ ne  "" } {
				putquick "privmsg $targ :[format [msg 3] $err]"
			} else {
				putlog [format [msg 3] $err]
			}
			if { [::mysql::state $dbcon -numeric] } { ::mysql::close $dbcon }
			return 0
		}
		#set q [::mysql::query $dbcon "SET NAMES cp1251"]
		#::mysql::endquery $q
		return 1
    }
	return 0
}

#      
proc playerexists { player } {
	variable dbcon
	return [lindex [::mysql::sel $dbcon "SELECT COUNT(*) FROM users WHERE name='$player'" -flatlist] 0]
}

#    
proc playeradd { player pass host } {
	variable startmoney;variable dbcon
	set host [::mysql::escape $dbcon [string map {~ ?} $host]]
	return [::mysql::exec $dbcon "INSERT INTO users (name,hosts,pass,score,regdate) VALUES ('$player','$host','$pass',$startmoney,NOW())"]
}

#  
proc top { nick uhost hand chan text } {
	variable topusers;variable dbcon
	if { [::mysql::state $dbcon -numeric] < 2 } { if { ![initconnect $chan] } { return } }
	
	set q [::mysql::sel $dbcon "SELECT name,score FROM users ORDER BY score DESC LIMIT $topusers" -list]
	if {![llength $q]} { putquick "privmsg $chan :[msg 42]";return }
	set topstring [format [msg 4] $topusers [lindex $q 0 0]]
	if { [isonline [lindex $q 0 0]] } {	append topstring "\002 ([getnickbylogin [lindex $q 0 0]])\002" }
	append topstring " [lindex $q 0 1]"
	for { set i 1 } { $i < $topusers } { incr i } {
		set plr [lindex $q $i 0];set scr [lindex $q $i 1]
		if { $plr eq "" || $scr eq "" || $scr <= 0 } { break }
		if { [isonline $plr] } {
			if { $::dicing::pls([getnickbylogin $plr],identified) } { append plr "\002 ([getnickbylogin $plr])\002" }
		}
		append topstring ", $plr $scr"
	}
	putquick "privmsg $chan :$topstring"
}

#   
proc reg { nick uhost hand text } {
	variable pref;variable startmoney;variable dbcon
	if {[info exists ::dicing::pls($nick,identified)]} {
		if { $::dicing::pls($nick,identified) } { putquick "privmsg $nick :[format [msg 5] $pref]";return }
	}
	if { [llength $text] != 2 } { putquick "privmsg $nick :[format [msg 6] $pref]";return }
	if { [::mysql::state $dbcon -numeric] < 2 } { if { ![initconnect $nick] } { return } }
	
	set player [::mysql::escape $dbcon [lindex $text 0]]
	set pass [md5 [lindex $text 1]]
	if { [playerexists $player] } {	putquick "privmsg $nick :[format [msg 7] $pref]";return	}
	if { ![playeradd $player $pass $uhost] } { putquick "privmsg $nick :[msg 9]";return }

	putquick "privmsg $nick :[format [msg 8] $nick $startmoney $pref]"
	set ::dicing::pls($nick,identified) 1
	set ::dicing::pls($nick,ident) [::mysql::insertid $dbcon]
	set ::dicing::pls($nick,login) $player
}

#   
proc leave { nick uhost hand text } {
	if { [info exists ::dicing::pls($nick,identified)] } {
		if { $::dicing::pls($nick,identified) } {
			set ::dicing::pls($nick,ident) 0;set ::dicing::pls($nick,identified) 0
			set ::dicing::pls($nick,login) "";set ::dicing::pls($nick,score) 0
			putquick "privmsg $nick :[format [msg 10] $nick]";return
		} else {
			putquick "privmsg $nick :[msg 11]";return
		}
	}
	putquick "privmsg $nick :[msg 11]"
}

#  
proc score { nick uhost hand arg1 {arg2 ""} } {
	variable dbcon
	if { ![info exists ::dicing::pls($nick,identified)] || !$::dicing::pls($nick,identified) } { return }
	if { [::mysql::state $dbcon -numeric] < 2 } { if { ![initconnect $nick] } { return } }
	set q [::mysql::query $dbcon "SELECT score FROM users WHERE id='$::dicing::pls($nick,ident)'"]
	set res [::mysql::fetch $q];::mysql::endquery $q
	if { ![info exists ::dicing::pls($nick,score)] } { set ::dicing::pls($nick,score) [lindex $res 0] }
	putquick "notice $nick :[format [msg 12] [lindex $res 0] $::dicing::pls($nick,score)]"

}

#  
proc transfer { nick uhost hand arg1 { arg2 ""} } {
	variable pref;variable transferAllowed;variable dbcon
	if { ![islogged $nick] } { return }
	if { [::mysql::state $dbcon -numeric] < 2 } { if { ![initconnect $nick] } { return } }
	if { [string index $arg1 0] ne "#" } { set mode "privmsg";set text $arg1 } else { set mode "notice";set text $arg2 }
	if { !$transferAllowed } { putquick "$mode $nick :[msg 43]";return }
	if { $text eq "" || [llength $text] != 2 } { putquick "$mode $nick :[format [msg 44] $pref]";return }
	set recepient [::mysql::escape $dbcon [lindex $text 0]]
	if { [tolower $recepient] eq [tolower [::mysql::escape $dbcon $nick]] } { putquick "$mode $nick :[msg 52]";return }
	set gift [lindex $text 1]
	if { ![isnumber $gift] || !$gift } { putquick "$mode $nick :[msg 45]";return }
	set q1 [::mysql::query $dbcon "SELECT score FROM users WHERE id='$::dicing::pls($nick,ident)'"]
	set res1 [::mysql::fetch $q1];::mysql::endquery $q1
	if { ![info exists ::dicing::pls($nick,score)] } { set ::dicing::pls($nick,score) [lindex $res1 0] }
	if { $::dicing::pls($nick,score) < $gift } { putquick "$mode $nick :[format [msg 17] $::dicing::pls($nick,score)]";return}
	set q [::mysql::query $dbcon "SELECT id FROM users where name='$recepient'"]
	set res [::mysql::fetch $q];::mysql::endquery $q
	if { [lindex $res 0] eq "" } { putquick "$mode $nick :[msg 46]";return }
	incr ::dicing::pls($nick,score) -$gift
	::mysql::exec $dbcon "UPDATE users SET score=score-$gift WHERE id='$::dicing::pls($nick,ident)'"
	putquick "$mode $nick :[format [msg 47] [lindex $text 0] $gift $::dicing::pls($nick,score)]"
	if { [isonline $recepient] } {
		set recnick [getnickbylogin $recepient]
        if { ![info exists ::dicing::pls($recnick,score)] } { set ::dicing::pls($recnick,score) [lindex $res1 0] }
		set ::dicing::pls($recnick,score) [expr $::dicing::pls($recnick,score)+$gift]
		putquick "$mode $recnick :[format [msg 48] $nick $gift $::dicing::pls($recnick,score)]"
	}
	set q [::mysql::query $dbcon "UPDATE users SET score=score+$gift WHERE name='$recepient'"]
}

#  
proc ident { nick uhost hand text } {
	variable pref;variable dbcon
    if { [llength $text] != 2 } { putquick "privmsg $nick :[format [msg 13] $pref]";return }
	if { [::mysql::state $dbcon -numeric] < 2 } { if { ![initconnect $nick] } { return } }
    if { [info exists ::dicing::pls($nick,identified)] } {
		if { $::dicing::pls($nick,identified) } { putquick "privmsg $nick :[format [msg 14] $::dicing::pls($nick,login)]";return }
    }
	
    set player [::mysql::escape $dbcon [lindex $text 0]]
	
	if { [isonline $player] } {	putquick "privmsg $nick :[msg 50]";return }
	
    set pass [md5 [lindex $text 1]]
    set q [::mysql::query $dbcon "SELECT * FROM users WHERE name='$player' and pass='$pass'"]
	set res [::mysql::fetch $q]
	::mysql::endquery $q	
	if { $res eq ""  } { putquick "privmsg $nick :[msg 16]";return }
    if { [lindex $res 0] } {
		putquick "privmsg $nick :[format [msg 15] $nick]"
		set ::dicing::pls($nick,identified) 1
		set ::dicing::pls($nick,ident) [lindex $res 0]
		set ::dicing::pls($nick,score) [lindex $res 4]
		set ::dicing::pls($nick,login) $player
    }
    return 0
}

#
#   MySQL
#
################################################################################

################################################################################
#
# 
#	 
#

proc tolower { s } { return [string map {                                                          A a B b C c D d E e F f G g H h I i J j K k L l M m N n O o P p Q q R r S s T t U u V v W w X x Y y Z z} $s] }
#      
proc msg { n } { return $::dicing::msg($n) }

proc islogged { n } {
	if { [info exists ::dicing::pls($n,identified)] } {	return $::dicing::pls($n,identified) }
	return 0
}

proc isonline { login } {
	if { $login eq "" } { return 0 }
	set logged [array names [namespace current]::pls "*,login"]
	if { ![llength $logged] } { return 0 }
	for { set i 0 } { $i < [llength $logged] } { incr i } {
		if { [tolower $::dicing::pls([lindex $logged $i])] eq [tolower $login] } { return 1 }
	}
	return 0
}

proc getnickbylogin { login } {
	if { $login eq "" } { return "" }
	set logged [array names [namespace current]::pls "*,login"]
	if { ![llength $logged] } { return "" }
	for { set i 0 } { $i < [llength $logged] } { incr i } {
		if {  [tolower $::dicing::pls([lindex $logged $i])] eq [tolower $login] } { return [lindex [split [lindex $logged $i] ","] 0] }
	}
	return ""
}

proc inform { chan left } {
    variable roundtime;variable utimer2;variable inform;variable roundstarted;variable started
	if { !$roundstarted || !$started } { return }
    putquick "privmsg $chan :[format [msg 49] [expr $roundtime-($left*$inform)] ]"
    incr left
    if { [expr $left*$inform] >= $roundtime } { return }
    set utimer2 [utimer $inform [list ::dicing::inform $chan $left]]
}

#      
proc clearround { } {
	variable players;variable number
	foreach nick $players { 
        set ::dicing::pls($nick,rate) 0;set ::dicing::pls($nick,gain) 0;set ::dicing::pls($nick,lose) 0
		if { [info exists ::dicing::pls($nick,score)] } { unset ::dicing::pls($nick,score)	}
	}
	set players ""
}

#        
proc listthrowers { } {
	variable throwers
	set b "[lindex $throwers 0] [lindex $throwers 1]"
	for { set i 2 } { $i <= [expr [llength $throwers]/2] } { incr i 2 } {
		append b ", [lindex $throwers $i] [lindex $throwers [expr $i+1]]"
	}
	return $b
}

#        
proc listwinners { } {
	variable winners
	set b "[lindex $winners 0] [lindex $winners 1]"
	for { set i 2 } { $i <= [expr [llength $winners]/2] } { incr i 2 } {
		append b ", [lindex $winners $i] [lindex $winners [expr $i+1]]"
	}
	return $b
}

proc srand {s} {
  set t1 [split $s x]
  return [expr [rand [expr [lindex $t1 1] - [lindex $t1 0] + 1]] + [lindex $t1 0]]
}

#
#   
#
################################################################################

################################################################################
#
# 
#	     

###   , ,   .
proc rate { nick uhost hand chan text } { if { [islogged $nick] } {	makebet $nick $chan "rate" $text } }

#     nick    .
#    nick   bet
proc addbet { nick type bet } {
	variable players;variable dbcon;variable number
	if {[lsearch -exact $players $nick] == -1 } {
		set players [linsert $players end $nick]
		if { ![info exists ::dicing::pls($nick,score)] } {
			set res [::mysql::sel $dbcon "SELECT score FROM users WHERE id='$::dicing::pls($nick,ident)'" -flatlist]
			set ::dicing::pls($nick,score) [lindex $res 0]
		}
	}
	if { $::dicing::pls($nick,score) >= $bet } {
		if {![info exists ::dicing::pls($nick,rate)]} { set ::dicing::pls($nick,rate) 0 }
		incr ::dicing::pls($nick,rate) $bet
		incr ::dicing::pls($nick,score) -$bet
		set ::dicing::pls($nick,number1) [srand 1x6]
		set ::dicing::pls($nick,number2) [srand 1x6]
		set ::dicing::pls($nick,number) [expr $::dicing::pls($nick,number1) + $::dicing::pls($nick,number2)]
		return 1
	}
		return 0
}

#     bet
proc makebet { nick chan type bet } {
	variable roundstarted;variable number
	if {![info exists ::dicing::pls($nick,number)] } { set ::dicing::pls($nick,number) "" }
	if { ![isnumber $bet] || !$bet || !$roundstarted } { return }
	if { ![addbet $nick $type $bet] } {
		putquick "notice $nick :[format [msg 17] $::dicing::pls($nick,score)]";return 0
	}
	switch $type {
		"rate" { set suffix [msg 18] }
	}
	putquick "notice $nick :[format [msg 25] $bet $::dicing::pls($nick,score)]"
	putquick "privmsg $chan :[format [msg 26] $nick $bet]"
}

#
#   
#
################################################################################

################################################################################
#
#  
#	,   
#

proc start { nick uhost hand chan text } {
	variable flag;variable started;variable roundstarted;variable roundtime;variable number;variable utimer;variable utimer2;variable inform;variable dbcon
	variable number1;variable number2
	if {![channel get $chan $flag] || $started } { return }
	if { [::mysql::state $dbcon -numeric] < 2 } { if { ![initconnect $nick] } { return } }
	set started 1;set roundstarted 1
	putquick "privmsg $chan :[msg 30]"
	putquick "privmsg $chan :[format [msg 31] $roundtime]"
	set number1 [srand 1x6]
	set number2 [srand 1x6]
	set number [expr $number1 + $number2]
	set utimer [utimer $roundtime [list ::dicing::endround $chan]]
	set utimer2 [utimer $inform [list ::dicing::inform $chan 1]]
	
}

proc stop { nick uhost hand chan text } { 
	variable started;variable roundstarted;variable utimer;variable utimer2
	if { !$started } { putquick "privmsg $chan :[format [msg 32] $nick]";return	}
	clearround
	set started 0
	set roundstarted 0
	catch {killutimer $utimer}
	set utimer ""
	catch {killutimer $utimer2}
	set utimer2 ""
	putquick "privmsg $chan :[msg 33]"
}

proc endround { chan } { 
	variable started;variable roundstarted;variable players
	if { !$started || !$roundstarted } { return }
	set roundstarted 0
	putquick "privmsg $chan :[msg 34]"
	putquick "privmsg $chan :[format [msg 51] [join $players {, }]]"
	utimer 5 [list ::dicing::continueround $chan]
}

proc continueround { chan } {
	variable players;variable rate;variable throwers;variable winners;variable number;variable roundDelay;variable dbcon
	variable number1;variable number2
	foreach nick $players { set ::dicing::pls($nick,gain) 0;set ::dicing::pls($nick,lose) 0	}
	foreach nick $players {
	    if { $::dicing::pls($nick,number) > $number} {
		set ::dicing::pls($nick,gain) [expr $::dicing::pls($nick,gain)+$::dicing::pls($nick,rate) * 2]
	    set ::dicing::pls($nick,lose) [expr $::dicing::pls($nick,lose)+$::dicing::pls($nick,rate)]
		} else {
	    set ::dicing::pls($nick,lose) [expr $::dicing::pls($nick,lose)+$::dicing::pls($nick,rate)]
		}
	}
	set throwers ""
	foreach nick $players {
		if { $::dicing::pls($nick,number) } { set throwers [linsert $throwers end [list $nick $::dicing::pls($nick,number1):$::dicing::pls($nick,number2)]] }
	}
	
	if { [::mysql::state $dbcon -numeric] < 2 } { if { ![initconnect $nick] } { return } }
	putquick "privmsg $chan :[msg 35]"
    putquick "privmsg $chan :[format [msg 37] $number1 $number2]"
	after 2500
	putquick "privmsg $chan :[msg 36]"
	if { $throwers eq "" } { putquick "privmsg $chan :[msg 61]" } else { putquick "privmsg $chan :[format [msg 62] [listthrowers]]" }
	after 2000
	set winners ""
	foreach nick $players {
		if { $::dicing::pls($nick,gain) } {	set winners [linsert $winners end [list $nick $::dicing::pls($nick,gain)]] }
		::mysql::exec $dbcon "UPDATE users SET score = ( score + $::dicing::pls($nick,gain) - $::dicing::pls($nick,lose) ) WHERE id='$::dicing::pls($nick,ident)'"
	}
	after 1000
	if { $winners eq "" } {	putquick "privmsg $chan :[msg 38]" } else {	putquick "privmsg $chan :[format [msg 39] [listwinners]]"}
	clearround
	set number1 [srand 1x6]
	set number2 [srand 1x6]
	set number [expr $number1 + $number2]
	putquick "privmsg $chan :[format [msg 40] $roundDelay]"
	utimer 7 [list ::dicing::nextround $chan]
}

proc nextround { chan } {
	variable roundstarted;variable roundtime;variable utimer;variable utimer2;variable inform
	set roundstarted 1
	putquick "privmsg $chan :[format [msg 41] $roundtime]"
	set utimer [utimer $roundtime [list ::dicing::endround $chan]]
	set utimer2 [utimer $inform [list ::dicing::inform $chan 1]]
}

#
#    
#
################################################################################

################################################################################
#
#  
#	   , IRC, netsplit,  ,  
#

bind part - * ::dicing::playerclear
bind kick - * ::dicing::playerkick
bind nick - * ::dicing::playerclear
bind splt - * ::dicing::playersplt
bind evnt - * ::dicing::ratet
bind sign - * ::dicing::playerclear
proc clearident { nick } {	set ::dicing::pls($nick,identified) 0;set ::dicing::pls($nick,ident) 0;set ::dicing::pls($nick,score) 0;set ::dicing::pls($nick,login) "" }
proc playerclear { nick uhost hand chan {arg ""} } { clearident $nick }
proc playersplt { nick uhost hand chan } { clearident $nick }
proc playerkick { nick uhost hand chan target reason } { clearident $target }

#
#    
#
################################################################################

putlog "dicing.tcl v$version by $author loaded ([expr ([clock clicks]-$::dicing::loadstart)/1000.0]ms)"
}